Index: Rosenbrock/scilab_rosen_wrapper.sci
===================================================================
--- Rosenbrock/scilab_rosen_wrapper.sci	(révision 0)
+++ Rosenbrock/scilab_rosen_wrapper.sci	(révision 0)
@@ -0,0 +1,41 @@
+// scilab_rosen_wrapper.sci
+function scilab_rosen_wrapper(params,results)
+
+exec('rosenbrock.sci');
+
+//--------------------------------------------------------------
+// Set any fixed/default values needed for your analysis .sci code
+//--------------------------------------------------------------
+
+alpha = 100;
+
+//------------------------------------------------------------------
+// READ params.in (or params.in.num) from DAKOTA and set Scilab variables
+//
+// read params.in (no aprepro) -- just one param per line
+//------------------------------------------------------------------
+
+fid = mopen(params,'r');
+C = mgetl(fid,-1);
+mclose(fid);
+
+// set design variables -- could use vector notation
+// rosenbrock x1, x2
+
+Line = tokens(C(2),' '); x(1) = eval(Line(1)); disp(x(1));
+Line = tokens(C(3),' '); x(2) = eval(Line(1)); disp(x(2));
+
+//------------------------------------------------------------------
+// CALL your analysis code to get the function value
+//------------------------------------------------------------------
+
+f = rosenbrock(x,alpha);
+
+//------------------------------------------------------------------
+// WRITE results.out
+//------------------------------------------------------------------
+
+fid = mopen(results,'w');
+mfprintf(fid,'%20.10e     f\n', f);
+mclose(fid);
+endfunction
Index: Rosenbrock/rosenbrock.sci
===================================================================
--- Rosenbrock/rosenbrock.sci	(révision 0)
+++ Rosenbrock/rosenbrock.sci	(révision 0)
@@ -0,0 +1,9 @@
+// rosenbrock
+//
+// return function values for the rosenbrock problem
+//		f( x1, x2 ) = alpha*( x2 - x1^2 )^2 + ( 1 - x1 )^2
+//
+// eventually: handle constraints, gradients, hessians
+function f = rosenbrock(x,alpha)
+  f = alpha*( x(2) - x(1)^2 )^2 + ( 1 - x(1) )^2;
+endfunction
Index: Rosenbrock/scilab_rosen_bb_simulator.bat
===================================================================
--- Rosenbrock/scilab_rosen_bb_simulator.bat	(révision 0)
+++ Rosenbrock/scilab_rosen_bb_simulator.bat	(révision 0)
@@ -0,0 +1,60 @@
+rem Sample simulator to Dakota system call script -- Scilab example
+rem See User Manual for instructions
+rem
+rem bvbw 10/24/01
+rem Brian M. Adams, 11/17/2005; 5/11/2009
+
+rem $1 is params.in FROM Dakota
+rem $2 is results.out returned to Dakota
+
+rem Assuming Scilab .sci files and any necessary data are in ./
+rem from which DAKOTA is run
+
+rem NOTE: The workdir could be eliminated since the scilab wrapper
+rem accepts parameters file names as input, but is included for example
+
+rem ------------------------
+rem Set up working directory
+rem ------------------------
+
+rem you could simplify this and keep all files in your main directory
+rem if you are only running one simulation at a time.
+
+rem strip function evaluation number for making working directory
+
+mkdir workdir
+
+echo "test : p1 = $1"
+echo "test : p2 = $2"
+
+rem copy parameters file from DAKOTA into working directory
+copy $1 workdir\params.in
+
+rem copy any necessary .m files and data files into workdir
+copy rosenbrock.sci scilab_rosen_wrapper.sci workdir
+
+rem ------------------------------------
+rem RUN the simulation from workdir.num
+rem ------------------------------------
+rem launch Scilab with command mode (-r)
+rem scilab_rosen_wrapper.sci will call the actual analysis file
+rem rosenbrock.sci
+cd workdir
+
+echo scilab -nwni -e "exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exit"
+
+scilab -nwni -e "exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exit"
+
+rem *** --> The 'exit' command is crucial so Scilab will exit after running
+rem         the analysis!
+
+
+rem -------------------------------
+rem write results.out.X and cleanup
+rem -------------------------------
+copy results.out ../$2 
+
+cd ..
+rmdir /s /q workdir
+
+
Index: Rosenbrock/dakota_scilab_rosenbrock.in
===================================================================
--- Rosenbrock/dakota_scilab_rosenbrock.in	(révision 0)
+++ Rosenbrock/dakota_scilab_rosenbrock.in	(révision 0)
@@ -0,0 +1,49 @@
+#  DAKOTA INPUT FILE - dakota_scilab_rosenbrock.in
+#  This sample Dakota input file optimizes the Rosenbrock function.
+#  See p. 95 in Practical Optimization by Gill, Murray, and Wright.
+#  
+# Here we use either the 
+#   scilab_rosen_bb_simulator.sh (Unix) or 
+#   scilab_rosen_bb_simulator.bat (Windows)
+# analysis driver that calls Scilab for each function evaluation
+
+method,                                         
+	conmin_frcg				
+
+variables,					
+	continuous_design = 2			
+	cdv_initial_point   -1.0      1.0	
+	cdv_lower_bounds    -2.0     -2.0	
+	cdv_upper_bounds     2.0      2.0	
+	cdv_descriptor       'x1'     'x2'
+
+interface,					
+
+# common options
+	fork,
+	parameters_file = 'params.in'		
+	results_file    = 'results.out'		
+
+# Use this line for Linux
+	analysis_driver = 'scilab_rosen_bb_simulator.sh'	
+
+# OR use this line for Windows
+##	analysis_driver = ' scilab_rosen_bb_simulator.bat'	
+
+# POSSIBLY use the following to perform 2 or more simultaneous Scilab
+# evaluations.  I haven't researched whether the automation
+# server supports this asynchronously, or whether one evaluation will
+# block the next (seems to work though)
+##       asynchronous                            
+##       evaluation_concurrency = 2
+##	 file_tag                                
+# use this to keep parameters/results files around if you wish (when
+# using file_tag only)
+##	file_save                               
+
+
+responses,                                      
+	num_objective_functions = 1             
+ 	numerical_gradients			
+ 	  fd_gradient_step_size = .000001	
+	no_hessians
Index: Rosenbrock/scilab_rosen_bb_simulator.sh
===================================================================
--- Rosenbrock/scilab_rosen_bb_simulator.sh	(révision 0)
+++ Rosenbrock/scilab_rosen_bb_simulator.sh	(révision 0)
@@ -0,0 +1,61 @@
+#!/bin/bash 
+# Sample simulator to Dakota system call script -- Scilab example
+# See User Manual for instructions
+#
+# yc 10/24/01
+# Yann Chapalain, 4/05/2011
+
+# $1 is params.in FROM Dakota
+# $2 is results.out returned to Dakota
+
+
+# Assuming Scilab .sci files and any necessary data are in ./
+# from which DAKOTA is run
+
+# NOTE: The workdir could be eliminated since the scilab wrapper
+# accepts parameters file names as input, but is included for example
+
+# ------------------------
+# Set up working directory
+# ------------------------
+
+# you could simplify this and keep all files in your main directory
+# if you are only running one simulation at a time.
+
+# strip function evaluation number for making working directory
+
+mkdir workdir
+
+echo "test : p1 = $1"
+echo "test : p2 = $2"
+
+# copy parameters file from DAKOTA into working directory
+cp $1 workdir/params.in
+
+# copy any necessary .sci files and data files into workdir
+cp rosenbrock.sci scilab_rosen_wrapper.sci workdir
+
+# -------------------------------
+# RUN the simulation from workdir
+# -------------------------------
+# launch Scilab with command mode (-r)
+# scilab_rosen_wrapper.sci will call the actual analysis file
+# rosenbrock.sci
+cd workdir
+
+echo scilab -nwni -e "exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exit"
+
+/home/yann/Programmes/scilab-5.3.1/bin/scilab -nwni -e "exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exit"
+
+# *** --> The 'exit' command is crucial so Scilab will exit after running
+#         the analysis!
+
+# -------------------------------
+# write results.out and cleanup
+# -------------------------------
+mv results.out ../$2 
+
+cd ..
+\rm -rf workdir
+
+

Modification de propriétés sur Rosenbrock/scilab_rosen_bb_simulator.sh
___________________________________________________________________
Ajouté : svn:executable
   + *

Index: FemTRUSS/bridge_optim_derivative.sce
===================================================================
--- FemTRUSS/bridge_optim_derivative.sce	(révision 0)
+++ FemTRUSS/bridge_optim_derivative.sce	(révision 0)
@@ -0,0 +1,59 @@
+lines(0);
+warning_old = warning('query');
+
+Order = 4; // 1 2 or 4 for derivative
+
+femtruss_path = get_absolute_file_path('bridge_optim_derivative.sce');
+exec(femtruss_path + 'build_long_bridge_2d.sce');
+
+function y = fobj_truss(x)
+[t,p,e,A,E,rho,F] = bridge_optim(x);
+[U,P,R]= femtruss(bridge_optim, %F, x);
+
+// The deck of the bridge is in IndexNodeVarInf
+y = sqrt(sum(U(2*(IndexNodeVarInf-1)+2).^2));
+endfunction
+
+function dy = dfobj_truss(x)
+dy = derivative(fobj_truss,x,order=Order)';
+endfunction
+
+function [y, dy, ind] = optim_fobj_truss(x, ind)
+y  = fobj_truss(x);
+dy = dfobj_truss(x)';
+endfunction
+
+////////////////////////////////////////////
+// Parameters for the optimization method //
+////////////////////////////////////////////
+
+MaxEvalFunc = 400;
+Algorithm   = 'gc'; // 'qn', 'gc', 'nd' -> Ne marche qu'avec 'qn' (quasi-newton). Pour les autres, on obtient rapidement une structure mal
+                    // conditionnee
+Log         = %F;
+TOL         = 1.0e-6; // accuracy for convergence test (minimum)
+
+//////////////////////////////
+// Main part of the problem //
+//////////////////////////////
+
+printf('optimization starting, be patient ... \n\n');
+
+[f_opt, x_opt] = optim(optim_fobj_truss, x0, algo=Algorithm,'ar',MaxEvalFunc,MaxEvalFunc,TOL,TOL);
+
+printf('initial solution:'); disp(x0');
+printf('initial objective function value = %f\n',fobj_truss(x0));
+
+printf('Final solution:'); disp(x_opt');
+printf('Final objective function value = %f\n',fobj_truss(x_opt));
+  
+scf();
+plot_fobj_truss(x0);
+xtitle('Before optimization','x','y');
+
+scf();
+plot_fobj_truss(x_opt);
+xtitle('After optimization','x','y');
+
+warning(warning_old);
+
Index: FemTRUSS/scilab_rosen_wrapper.sci
===================================================================
--- FemTRUSS/scilab_rosen_wrapper.sci	(révision 0)
+++ FemTRUSS/scilab_rosen_wrapper.sci	(révision 0)
@@ -0,0 +1,44 @@
+// scilab_rosen_wrapper.sci
+function scilab_rosen_wrapper(params,results)
+
+exec('f.sci');
+exec('fp.sci');
+exec('build_long_bridge_2d.sce');
+exec('bridge_optim_derivative.sce');
+
+//--------------------------------------------------------------
+// Set any fixed/default values needed for your analysis .sci code
+//--------------------------------------------------------------
+
+//alpha = 100;
+
+//------------------------------------------------------------------
+// READ params.in (or params.in.num) from DAKOTA and set Scilab variables
+//
+// read params.in (no aprepro) -- just one param per line
+//------------------------------------------------------------------
+
+fid = mopen(params,'r');
+C = mgetl(fid,-1);
+mclose(fid);
+
+// set design variables -- could use vector notation
+
+Line = tokens(C(2),' '); x(1) = eval(Line(1)); disp(x(1));
+Line = tokens(C(3),' '); x(2) = eval(Line(1)); disp(x(2));
+
+//------------------------------------------------------------------
+// CALL your analysis code to get the function value
+//------------------------------------------------------------------
+
+f = f(x);
+f2 = fp(x);
+
+//------------------------------------------------------------------
+// WRITE results.out
+//------------------------------------------------------------------
+
+fid = mopen(results,'w');
+mfprintf(fid,'%20.10e     f\n', f);
+mclose(fid);
+endfunction
Index: FemTRUSS/build_long_bridge_3d_good.sce
===================================================================
--- FemTRUSS/build_long_bridge_3d_good.sce	(révision 0)
+++ FemTRUSS/build_long_bridge_3d_good.sce	(révision 0)
@@ -0,0 +1,161 @@
+lines(0);
+warning_old = warning('query');
+
+NbBlocs = 8; // The number of blocks for the bridge.
+
+global IndexNodeVarSup;
+global IndexNodeVarInf;
+
+IndexNodeVarSup = []; // This list will handles the number of the nodes we are allowed to move
+IndexNodeVarInf = []; // This list will handles the number of the nodes where we compute the deformation of the deck of the bridge
+
+// Definition of the initial solution. Depends on the number of blocks
+x0 = zeros(2*NbBlocs+2,3);
+
+//IndexNodeVarSup = [IndexNodeVarSup 4*(i-1)+3+5 4*(i-1)+3+7];
+
+NbPts = size(x0(1:2:$,1),1);
+
+// i+1 1 0;  // 4*(i-1)+3+5
+x0(1:2:$,1) = (1:NbPts)';
+x0(1:2:$,2) = 1;
+x0(1:2:$,3) = 0;
+
+// i+1 1 1]; // 4*(i-1)+3+7
+x0(2:2:$,1) = (1:NbPts)';
+x0(2:2:$,2) = 1;
+x0(2:2:$,3) = 1;
+
+x0 = matrix(x0',length(x0),1);
+
+function [t,p,e,A,E,rho,F] = bridge_optim_3d(x)
+global IndexNodeVarSup;
+global IndexNodeVarInf;
+
+// t : donnees en lignes regroupees par 2 (connection extremite 1 - connection extremite 2)
+// p : autant de lignes que de noeuds. Sur chaque ligne n on retrouve les coordonnees 2d du noeud n
+// e : liste des noeuds d'appui
+// A : liste des sections des elements. Vecteur contenant autant d'entrees que d'elements
+// E : liste des modules d'elasticite des elements. Vecteur contenant autant d'entrees que d'elements
+// rho : liste des masses volumiques des elements. Vecteur contenant autant d'entrees que d'elements
+// F   : liste des forces appliquees aux noeuds. Vecteur colonne comprenant la coordonnes X du noeud 1 en premiere ligne, la coordonnees Y du noeud 1 en seconde 
+//       ligne, etc ...
+
+IndexNodeVarSup = [];
+IndexNodeVarInf = [];
+
+//      4       6
+//      +       +
+//     /       /
+//    /       / 
+//   /       /  
+// -+---+  -+---+
+//  |1  3   |2  5
+
+p = [0 0 0;
+     0 0 1;
+     1 0 0;
+     1 1 0;
+     1 0 1;
+     1 1 1];
+     
+t = [1 3;
+     1 4;
+     2 5;
+     2 6;
+     1 2;
+     3 5;
+     4 6;
+     1 5;
+     2 3;
+     3 6;
+     4 5];
+
+IndexNodeVarSup = [4 6];
+IndexNodeVarInf = [3 5];
+
+for i=1:NbBlocs
+  //  4*(i-1)+3+1 4*(i-1)+3+5  4*(i-1)+3+3 4*(i-1)+3+7    
+  //  +----+                      +----+
+  //  |\  /                       |\  /
+  //  | /\                        | /\ 
+  //  |/  \                       |/  \
+  //  +----+                      +----+
+  //  4*(i-1)+3+0 4*(i-1)+3+4  4*(i-1)+3+2 4*(i-1)+3+6
+
+  p = [p; 
+       i+1 0 0;  // 4*(i-1)+3+4
+       i+1 1 0;  // 4*(i-1)+3+5
+       i+1 0 1;  // 4*(i-1)+3+6
+       i+1 1 1]; // 4*(i-1)+3+7
+       
+  t = [t; 
+       4*(i-1)+3+0 4*(i-1)+3+4; // First face
+       4*(i-1)+3+1 4*(i-1)+3+5;
+       4*(i-1)+3+0 4*(i-1)+3+1;
+       4*(i-1)+3+0 4*(i-1)+3+5;
+       4*(i-1)+3+1 4*(i-1)+3+4;
+       4*(i-1)+3+2 4*(i-1)+3+6; // Second face
+       4*(i-1)+3+3 4*(i-1)+3+7;
+       4*(i-1)+3+2 4*(i-1)+3+3;
+       4*(i-1)+3+3 4*(i-1)+3+6;
+       4*(i-1)+3+2 4*(i-1)+3+7;
+       4*(i-1)+3+1 4*(i-1)+3+7; // Above cross
+       4*(i-1)+3+3 4*(i-1)+3+5;
+       4*(i-1)+3+0 4*(i-1)+3+6; // Below cross
+       4*(i-1)+3+4 4*(i-1)+3+2;
+       4*(i-1)+3+4 4*(i-1)+3+7; // Cross inside
+       4*(i-1)+3+5 4*(i-1)+3+6];
+       
+  IndexNodeVarSup = [IndexNodeVarSup 4*(i-1)+3+5 4*(i-1)+3+7];
+  IndexNodeVarInf = [IndexNodeVarInf 4*(i-1)+3+4 4*(i-1)+3+6];
+end
+
+//  4*(i-1)+1               4*(i-1)+3   
+//  +                          +       
+//   \                          \   
+//    \                          \
+//     \                          \ 
+// +---+                       +---+
+// 4*(i-1)+0 4*i(i-1)4      4*(i-1)+2 4*(i-1)+5
+
+p = [p; 
+     NbBlocs+2 0 0;
+     NbBlocs+2 0 1;];
+
+t = [t;
+     4*(NbBlocs)+3+0 4*(NbBlocs)+3+1;
+     4*(NbBlocs)+3+2 4*(NbBlocs)+3+3;
+     4*(NbBlocs)+3+0 4*(NbBlocs)+3+4;
+     4*(NbBlocs)+3+2 4*(NbBlocs)+3+5;
+     4*(NbBlocs)+3+1 4*(NbBlocs)+3+4;
+     4*(NbBlocs)+3+3 4*(NbBlocs)+3+5;
+     4*(NbBlocs)+3+4 4*(NbBlocs)+3+5;
+     4*(NbBlocs)+3+0 4*(NbBlocs)+3+5;
+     4*(NbBlocs)+3+2 4*(NbBlocs)+3+4]
+    
+e = [
+     [1, 1, 1] .* localise3d(1);
+     [1, 1, 1] .* localise3d(2);
+     [1, 1, 1] .* localise3d(4*NbBlocs+3+4);
+     [1, 1, 1] .* localise3d(4*NbBlocs+3+5);
+    ]; 
+
+A   = ones(1,size(t,1)) * 25e-4; // sections des elements
+E   = ones(1,size(t,1)) * 210e9; // module d'elasticite des elements 
+rho = ones(1,size(t,1)) * 7.8e3; // masse volumique des elements
+
+F = zeros(length(p),1);
+F(3*(IndexNodeVarInf-1)+2) = -3.4e5;
+
+p(IndexNodeVarSup,1) = x(1:3:$);
+p(IndexNodeVarSup,2) = x(2:3:$);
+p(IndexNodeVarSup,3) = x(3:3:$);
+endfunction
+
+function plot_fobj_truss(x)
+[t,p,e,A,E,rho,F] = bridge_optim_3d(x);
+[U,P,R]= femtruss(bridge_optim_3d, %F, x);
+plotdeforme(U,p,t,10);
+endfunction
+
Index: FemTRUSS/bridge_optim_derivative_init.sce
===================================================================
--- FemTRUSS/bridge_optim_derivative_init.sce	(révision 0)
+++ FemTRUSS/bridge_optim_derivative_init.sce	(révision 0)
@@ -0,0 +1,59 @@
+lines(0);
+warning_old = warning('query');
+
+Order = 4; // 1 2 or 4 for derivative
+
+femtruss_path = get_absolute_file_path('bridge_optim_derivative.sce');
+exec(femtruss_path + 'build_long_bridge_2d.sce');
+
+function y = fobj_truss(x)
+[t,p,e,A,E,rho,F] = bridge_optim(x);
+[U,P,R]= femtruss(bridge_optim, %F, x);
+
+// The deck of the bridge is in IndexNodeVarInf
+y = sqrt(sum(U(2*(IndexNodeVarInf-1)+2).^2));
+endfunction
+
+function dy = dfobj_truss(x)
+dy = derivative(fobj_truss,x,order=Order)';
+endfunction
+
+function [y, dy, ind] = optim_fobj_truss(x, ind)
+y  = fobj_truss(x);
+dy = dfobj_truss(x)';
+endfunction
+
+////////////////////////////////////////////
+// Parameters for the optimization method //
+////////////////////////////////////////////
+
+MaxEvalFunc = 400;
+Algorithm   = 'gc'; // 'qn', 'gc', 'nd' -> Ne marche qu'avec 'qn' (quasi-newton). Pour les autres, on obtient rapidement une structure mal
+                    // conditionnee
+Log         = %F;
+TOL         = 1.0e-6; // accuracy for convergence test (minimum)
+
+//////////////////////////////
+// Main part of the problem //
+//////////////////////////////
+
+printf('optimization starting, be patient ... \n\n');
+
+[f_opt, x_opt] = optim(optim_fobj_truss, x0, algo=Algorithm,'ar',MaxEvalFunc,MaxEvalFunc,TOL,TOL);
+
+printf('initial solution:'); disp(x0');
+printf('initial objective function value = %f\n',fobj_truss(x0));
+
+printf('Final solution:'); disp(x_opt');
+printf('Final objective function value = %f\n',fobj_truss(x_opt));
+  
+scf();
+plot_fobj_truss(x0);
+xtitle('Before optimization','x','y');
+
+scf();
+plot_fobj_truss(x_opt);
+xtitle('After optimization','x','y');
+
+warning(warning_old);
+
Index: FemTRUSS/fp.sci
===================================================================
--- FemTRUSS/fp.sci	(révision 0)
+++ FemTRUSS/fp.sci	(révision 0)
@@ -0,0 +1,8 @@
+function dy = df(x)
+	 dy = derivative(fobj_truss,x,order=Order)';
+endfunction
+
+//function [y, dy, ind] = optim_fobj_truss(x, ind)
+//y  = fobj_truss(x);
+//dy = dfobj_truss(x)';
+//endfunction
Index: FemTRUSS/f.sci
===================================================================
--- FemTRUSS/f.sci	(révision 0)
+++ FemTRUSS/f.sci	(révision 0)
@@ -0,0 +1,19 @@
+// bridge_optim_derivative.sci
+
+
+function y = f(x)
+	 [t,p,e,A,E,rho,F] = bridge_optim(x);
+	 [U,P,R]= femtruss(bridge_optim, %F, x);
+
+	 // The deck of the bridge is in IndexNodeVarInf
+	 y = sqrt(sum(U(2*(IndexNodeVarInf-1)+2).^2));
+endfunction
+
+function dy = df(x)
+	 dy = derivative(fobj_truss,x,order=Order)';
+endfunction
+
+//function [y, dy, ind] = optim_fobj_truss(x, ind)
+//y  = fobj_truss(x);
+//dy = dfobj_truss(x)';
+//endfunction
Index: FemTRUSS/init_bridge_optim_derivative.sce
===================================================================
--- FemTRUSS/init_bridge_optim_derivative.sce	(révision 0)
+++ FemTRUSS/init_bridge_optim_derivative.sce	(révision 0)
@@ -0,0 +1,7 @@
+lines(0);
+warning_old = warning('query');
+
+femtruss_path = get_absolute_file_path('init_bridge_optim_derivative.sce');
+exec(femtruss_path + 'build_long_bridge_2d.sce');
+
+
Index: FemTRUSS/bridge_optim_derivative.sci
===================================================================
--- FemTRUSS/bridge_optim_derivative.sci	(révision 0)
+++ FemTRUSS/bridge_optim_derivative.sci	(révision 0)
@@ -0,0 +1,12 @@
+// bridge_optim_derivative.sci
+
+
+function y = f(x)
+	 [t,p,e,A,E,rho,F] = bridge_optim(x);
+	 [U,P,R]= femtruss(bridge_optim, %F, x);
+
+	 // The deck of the bridge is in IndexNodeVarInf
+	 y = sqrt(sum(U(2*(IndexNodeVarInf-1)+2).^2));
+endfunction
+
+
Index: FemTRUSS/bridge_optim_3d_derivative.sce
===================================================================
--- FemTRUSS/bridge_optim_3d_derivative.sce	(révision 0)
+++ FemTRUSS/bridge_optim_3d_derivative.sce	(révision 0)
@@ -0,0 +1,83 @@
+// Work done by Ms. Ibrahimcha, Nkamani, Hammad.
+
+lines(0);
+warning_old = warning('query');
+
+warning('off');
+
+Order = 4; // 1 2 or 4 for derivative
+Debug = %T;
+delta_h = 1e-6;
+
+femtruss_path = get_absolute_file_path('bridge_optim_3d_derivative.sce');
+
+//exec(femtruss_path + 'build_long_bridge_3d_bad.sce');
+exec(femtruss_path + 'build_long_bridge_3d_good.sce');
+  
+function y = fobj_truss(x)
+[t,p,e,A,E,rho,F] = bridge_optim_3d(x);
+[U,P,R]= femtruss(bridge_optim_3d, %F, x);
+
+// First objective: minimize the deformation at nodes of the deck with respect to y (coordinate 2)
+
+// The deck of the bridge
+Pos_deck  = localise3d(IndexNodeVarInf);
+
+y = sqrt(sum(U(Pos_deck(2:3:$)).^2));
+endfunction
+
+function dy=dfobj_truss_diff(x)
+dy = derivative(fobj_truss,x,delta_h,Order)';
+endfunction
+
+function [y, dy, ind] = optim_fobj_truss(x, ind)
+y  = fobj_truss(x);
+dy = dfobj_truss_diff(x);
+
+if Debug then
+  printf('y = %f\n', y);
+  printf('norm(dy) = %f - abs(dy): max = %f min = %f\n', norm(dy), max(abs(dy)), min(abs(dy)));
+end
+endfunction
+
+MaxEvalFunc = 40;
+Algorithm   = 'gc'; // 'qn', 'gc', 'nd' -> Ne marche qu'avec 'qn' (quasi-newton). Pour les autres, on obtient rapidement une structure mal
+                    // conditionnee
+Tol = 1e-12;
+
+////////////////////////////
+// Start the Optimization //
+////////////////////////////
+
+printf('optimization starting, be patient ... \n\n');
+
+tic();
+//[f_opt, x_opt] = optim(optim_fobj_truss, 'b',lower, upper, x0, 'gc','ar',1000,1000,1e-6,1e-6);
+//[f_opt, x_opt] = optim(optim_fobj_truss, 'b',lower, upper, x0, 'gc','ar',1000,1000,1e-12,1e-12);
+
+// Be careful: the 'gc' algorithm doesn't seems to accept bounds constraint
+
+[f_opt, x_opt] = optim(optim_fobj_truss, x0, Algorithm,'ar',MaxEvalFunc,MaxEvalFunc,Tol,Tol);
+
+printf('initial solution:'); disp(x0');
+printf('initial objective function value = %f\n',fobj_truss(x0));
+printf('Final solution:'); disp(x_opt');
+printf('Final objective function value = %f\n',fobj_truss(x_opt));
+  
+t_end=toc();
+printf('computation time = %f\n' , t_end);
+
+////////////////////////
+// Plot the solutions //
+////////////////////////
+
+scf();
+plot_fobj_truss(x0);
+xtitle('Before optimization','x','y','z');
+
+scf();
+plot_fobj_truss(x_opt);
+xtitle('After optimization','x','y','z');
+
+warning(warning_old);
+
Index: FemTRUSS/final_bridge_optim_derivative.sce
===================================================================
--- FemTRUSS/final_bridge_optim_derivative.sce	(révision 0)
+++ FemTRUSS/final_bridge_optim_derivative.sce	(révision 0)
@@ -0,0 +1,7 @@
+
+
+scf();
+plot_fobj_truss(x_opt);
+xtitle('After optimization','x','y');
+
+warning(warning_old);
Index: FemTRUSS/build_long_bridge_2d.sce
===================================================================
--- FemTRUSS/build_long_bridge_2d.sce	(révision 0)
+++ FemTRUSS/build_long_bridge_2d.sce	(révision 0)
@@ -0,0 +1,107 @@
+NbBlocs = 8; // The number of blocks for the bridge.
+
+global IndexNodeVarSup;
+global IndexNodeVarInf;
+
+IndexNodeVarSup = [];
+IndexNodeVarInf = [];
+
+// Definition of the initial solution. Depends on the number of blocks
+x0 = zeros(2*(NbBlocs+1),1);
+x0(2:2:$) = 1;
+x0(1:2:$) = (1:NbBlocs+1)';
+
+function [t,p,e,A,E,rho,F] = bridge_optim(x)
+// t : donnees en lignes regroupees par 2 (connection extremite 1 - connection extremite 2)
+// p : autant de lignes que de noeuds. Sur chaque ligne n on retrouve les coordonnees 2d du noeud n
+// e : liste des noeuds d'appui
+// A : liste des sections des elements. Vecteur contenant autant d'entrees que d'elements
+// E : liste des modules d'elasticite des elements. Vecteur contenant autant d'entrees que d'elements
+// rho : liste des masses volumiques des elements. Vecteur contenant autant d'entrees que d'elements
+// F   : liste des forces appliquees aux noeuds. Vecteur colonne comprenant la coordonnes X du noeud 1 en premiere ligne, la coordonnees Y du noeud 1 en seconde 
+//       ligne, etc ...
+
+global IndexNodeVarSup;
+global IndexNodeVarInf;
+
+IndexNodeVarSup = [];
+IndexNodeVarInf = [];
+
+//      3
+//      +
+//     /
+//    / 
+//   /  
+// -+---+
+//  |1  2
+
+p = [0 0;
+     1 0;
+     1 1];
+     
+t = [1 2;
+     1 3];
+
+IndexNodeVarSup = 3;
+IndexNodeVarInf = 2;
+
+for i=1:NbBlocs
+  //  2*i+1 2*i+3    
+  //  +----+
+  //  |\  /
+  //  | /\ 
+  //  |/  \
+  //  +----+
+  //  2*i+0 2*i+2
+
+  p = [p; 
+       i+1 0;
+       i+1 1];
+       
+  t = [t; 
+       2*i+0 2*i+1;
+       2*i+1 2*i+3;
+       2*i+0 2*i+2;
+       2*i+0 2*i+3;
+       2*i+1 2*i+2];
+       
+  IndexNodeVarSup = [IndexNodeVarSup 2*i+3];
+  IndexNodeVarInf = [IndexNodeVarInf 2*i+2];
+end
+
+//  2*i+1   
+//  +       
+//   \   
+//    \
+//     \ 
+// +---+
+// 2*i+0 2*i+2   
+p = [p; 
+     NbBlocs+2 0];
+
+t = [t; 
+     2*(NbBlocs+1)+0 2*(NbBlocs+1)+2;
+     2*(NbBlocs+1)+1 2*(NbBlocs+1)+2;
+     2*(NbBlocs+1)+0 2*(NbBlocs+1)+1];
+
+e = [
+     [1, 1] .* localise2d(1) // On localise les positions du noeud 6 dans les matrices et on immobilise les deux degrees de liberte du noeud 5
+     [1, 1] .* localise2d(2*(NbBlocs-1)+6) // On localise les positions du noeud 6 dans les matrices et on immobilise les deux degrees de liberte du noeud 2
+    ]; 
+
+A   = ones(1,size(t,1)) * 25e-4; // sections des elements
+E   = ones(1,size(t,1)) * 210e9; // module d'elasticite des elements 
+rho = ones(1,size(t,1)) * 7.8e3; // masse volumique des elements
+
+F = zeros(length(p),1);
+F(2*(IndexNodeVarInf-1)+2) = -3.4e5;
+
+p(IndexNodeVarSup,1) = x(1:2:$);
+p(IndexNodeVarSup,2) = x(2:2:$);
+endfunction
+
+function plot_fobj_truss(x)
+[t,p,e,A,E,rho,F] = bridge_optim(x);
+[U,P,R]= femtruss(bridge_optim, %F, x);
+plotdeforme(U,p,t,10);
+endfunction
Index: FemTRUSS/bridge_optim_derivative.in
===================================================================
--- FemTRUSS/bridge_optim_derivative.in	(révision 0)
+++ FemTRUSS/bridge_optim_derivative.in	(révision 0)
@@ -0,0 +1,34 @@
+# bridge_optim_derivative.in
+
+method,
+        optpp_q_newton
+          max_iterations = 40,
+          convergence_tolerance = 1.0e-6
+
+variables,
+        continuous_design = 18
+          cdv_initial_point  1.  1.  2.  1.  3.  1.  4.  1.  5.  1.  6.  1.  7.  1.  8.  1.  9.  1.
+          cdv_lower_bounds  -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10 -10
+          cdv_upper_bounds   10  10  10  10  10  10  10  10  10  10  10  10  10  10  10  10  10  10
+          cdv_descriptor     'x1' 'x2' 'x3' 'x4' 'x5' 'x6' 'x7' 'x8' 'x9' 'x10' 'x11' 'x12' 'x13' 'x14' 'x15' 'x16' 'x17' 'x18' 
+
+interface,
+        fork
+          analysis_driver = 'scilab_rosen_bb_simulator.sh',
+          parameters_file = 'params.in'
+          results_file = 'results.out'
+          deactivate active_set_vector
+
+responses,
+        num_objective_functions = 1
+##      analytic_gradients                      #0,#1,#2,#3
+        numerical_gradients                     #4
+          method_source dakota                  #4
+          interval_type central                 #4
+          fd_gradient_step_size = 1.e-3         #4
+        no_hessians
+##      analytic_hessians                       #0
+#       quasi_hessians damped bfgs              #1
+#       quasi_hessians sr1                      #2
+##      numerical_hessians                      #3,#4
+##        fd_hessian_step_size = 1.e-5          #3,#4
Index: FemTRUSS/scilab_rosen_bb_simulator.sh
===================================================================
--- FemTRUSS/scilab_rosen_bb_simulator.sh	(révision 0)
+++ FemTRUSS/scilab_rosen_bb_simulator.sh	(révision 0)
@@ -0,0 +1,65 @@
+#!/bin/bash 
+# Sample simulator to Dakota system call script -- Scilab example
+# See User Manual for instructions
+#
+# yc 10/24/01
+# Yann Chapalain, 4/05/2011
+
+# $1 is params.in FROM Dakota
+# $2 is results.out returned to Dakota
+
+
+# Assuming Scilab .sci files and any necessary data are in ./
+# from which DAKOTA is run
+
+# NOTE: The workdir could be eliminated since the scilab wrapper
+# accepts parameters file names as input, but is included for example
+
+# ------------------------
+# Set up working directory
+# ------------------------
+
+# you could simplify this and keep all files in your main directory
+# if you are only running one simulation at a time.
+
+# strip function evaluation number for making working directory
+
+mkdir workdir
+
+echo "test : p1 = $1"
+echo "test : p2 = $2"
+
+# copy parameters file from DAKOTA into working directory
+cp $1 workdir/params.in
+
+# copy any necessary .sci files and data files into workdir
+#cp init_bridge_optim_derivative.sce final_bridge_optim_derivative.sce f.sci fp.sci scilab_rosen_wrapper.sci build_long_bridge_2d.sce workdir
+
+cp *sci *sce workdir
+
+# -------------------------------
+# RUN the simulation from workdir
+# -------------------------------
+# launch Scilab with command mode (-r)
+# scilab_rosen_wrapper.sci will call the actual analysis file
+# rosenbrock.sci
+cd workdir
+
+echo scilab -nwni -e "exec init_bridge_optim_derivative.sce; exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); final_bridge_optim_derivative.sce; exit"
+
+/home/yann/Programmes/scilab-5.3.1/bin/scilab  -e "exec init_bridge_optim_derivative.sce; exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exec final_bridge_optim_derivative.sce; exit"
+
+
+
+# *** --> The 'exit' command is crucial so Scilab will exit after running
+#         the analysis!
+
+# -------------------------------
+# write results.out and cleanup
+# -------------------------------
+mv results.out ../$2 
+
+cd ..
+\rm -rf workdir
+
+

Modification de propriétés sur FemTRUSS/scilab_rosen_bb_simulator.sh
___________________________________________________________________
Ajouté : svn:executable
   + *

Index: readme_scilab
===================================================================
--- readme_scilab	(révision 0)
+++ readme_scilab	(révision 0)
@@ -0,0 +1,55 @@
+DAKOTA/Scilab script interface
+Yann Chapalain
+07/20/2011;
+==============================
+
+FILES:
+
+First example : Rosenbrock function
+
+	dakota_scilab_rosenbrock.in	DAKOTA input file
+	
+	scilab_rosen_bb_simulator.sh  	analysis driver script called by DAKOTA
+     OR scilab_rosen_bb_simulator.bat
+
+     	scilab_rosen_wrapper.sci	scilab wrapper called by script
+	rosenbrock.sci            	objective function
+	  
+Second example : PID
+
+       pid.in				DAKOTA input file
+
+       scilab_rosen_bb_simulator.sh  	analysis driver script called by DAKOTA
+    OR scilab_rosen_bb_simulator.bat
+
+       init_test_automatic.sce		init xcos script called by shell script
+       visualize_solution.sce		script to visualize xcos solution
+       					called by shell script
+       scilab_rosen_wrapper.sci	scilab	wrapper called by shell script
+       f_pid.sci            		objective function
+       
+Third example : Bridge FemTRUSS
+FemTRUSS is a Truss finite element code for scilab.
+
+       bridge_optim_derivative.in	DAKOTA input file
+
+       scilab_rosen_bb_simulator.sh  	analysis driver script called by DAKOTA
+    OR scilab_rosen_bb_simulator.bat
+
+       init_bridge_optim_derivative.sce		init FemTRUSS script called by shell script
+       final_bridge_optim_derivative.sce	script to visualize FemTRUSS solution
+       						called by shell script
+       scilab_rosen_wrapper.sci	scilab	wrapper called by shell script
+       f.sci            		objective function
+       fp.sci				gradient
+
+      
+EXECUTION:
+
+This example presumes the Scilab executable is on the path.  If not,
+you'll need to modify the scilab_rosen_bb_simulator.* of the specific
+example include the explicit path to it.
+
+To run the Rosenbrockexample (minimize rosenbrock function using CONMIN's FRCG alg.):
+
+	dakota -i dakota_scilab_rosenbrock.in
Index: PID/visualize_solution.sce
===================================================================
--- PID/visualize_solution.sce	(révision 0)
+++ PID/visualize_solution.sce	(révision 0)
@@ -0,0 +1,17 @@
+loadXcosLibs();
+
+importXcosDiagram('automatic_test.xcos');
+
+// We find a good solution, but it doesn't take into account the stability of the system.
+w0 = 2*%pi*100;
+m  = 0.5;
+K0 = 0.1;
+
+context = [];
+context.w0 = w0; ...
+context.m  = m; ...
+context.K0 = K0; ...
+context.P = 233;
+context.I = 0.59;
+
+Info = scicos_simulate(scs_m,list(),context);
Index: PID/scilab_rosen_wrapper.sci
===================================================================
--- PID/scilab_rosen_wrapper.sci	(révision 0)
+++ PID/scilab_rosen_wrapper.sci	(révision 0)
@@ -0,0 +1,41 @@
+// scilab_rosen_wrapper.sci
+function scilab_rosen_wrapper(params,results)
+
+exec('f_pid.sci');
+
+//--------------------------------------------------------------
+// Set any fixed/default values needed for your analysis .sci code
+//--------------------------------------------------------------
+
+//alpha = 100;
+
+//------------------------------------------------------------------
+// READ params.in (or params.in.num) from DAKOTA and set Scilab variables
+//
+// read params.in (no aprepro) -- just one param per line
+//------------------------------------------------------------------
+
+fid = mopen(params,'r');
+C = mgetl(fid,-1);
+mclose(fid);
+
+// set design variables -- could use vector notation
+// rosenbrock x1, x2
+
+Line = tokens(C(2),' '); x(1) = eval(Line(1)); disp(x(1));
+Line = tokens(C(3),' '); x(2) = eval(Line(1)); disp(x(2));
+
+//------------------------------------------------------------------
+// CALL your analysis code to get the function value
+//------------------------------------------------------------------
+
+f = f(x);
+
+//------------------------------------------------------------------
+// WRITE results.out
+//------------------------------------------------------------------
+
+fid = mopen(results,'w');
+mfprintf(fid,'%20.10e     f\n', f);
+mclose(fid);
+endfunction
Index: PID/pid.in
===================================================================
--- PID/pid.in	(révision 0)
+++ PID/pid.in	(révision 0)
@@ -0,0 +1,28 @@
+# pid.in
+
+method,
+	optpp_q_newton
+	  max_iterations = 40,
+	  convergence_tolerance = 1e-3
+
+variables,
+	continuous_design = 2
+	  cdv_initial_point    1      1
+	  cdv_lower_bounds     0.01   0.01
+	  cdv_upper_bounds     1000   2.0
+	  cdv_descriptor       'P'   'I'
+
+interface,
+	fork
+	  analysis_driver = 'scilab_rosen_bb_simulator.sh'
+	  parameters_file = 'params.in'
+	  results_file = 'results.out'
+	  deactivate active_set_vector
+
+responses,
+	num_objective_functions = 1
+	numerical_gradients	        	#4
+	  method_source dakota	        	#4
+	  interval_type central	        	#4
+	  fd_gradient_step_size = 1.e-3 	#4
+	no_hessians
Index: PID/init_test_automatic.sce
===================================================================
--- PID/init_test_automatic.sce	(révision 0)
+++ PID/init_test_automatic.sce	(révision 0)
@@ -0,0 +1,7 @@
+loadXcosLibs();
+
+importXcosDiagram('automatic_test.xcos');
+
+w0 = 2*%pi*100;
+m  = 0.5;
+K0 = 0.1;
Index: PID/scilab_rosen_bb_simulator.sh
===================================================================
--- PID/scilab_rosen_bb_simulator.sh	(révision 0)
+++ PID/scilab_rosen_bb_simulator.sh	(révision 0)
@@ -0,0 +1,61 @@
+#!/bin/bash 
+# Sample simulator to Dakota system call script -- Scilab example
+# See User Manual for instructions
+#
+# yc 10/24/01
+# Yann Chapalain, 4/05/2011
+
+# $1 is params.in FROM Dakota
+# $2 is results.out returned to Dakota
+
+
+# Assuming Scilab .sci files and any necessary data are in ./
+# from which DAKOTA is run
+
+# NOTE: The workdir could be eliminated since the scilab wrapper
+# accepts parameters file names as input, but is included for example
+
+# ------------------------
+# Set up working directory
+# ------------------------
+
+# you could simplify this and keep all files in your main directory
+# if you are only running one simulation at a time.
+
+# strip function evaluation number for making working directory
+
+mkdir workdir
+
+echo "test : p1 = $1"
+echo "test : p2 = $2"
+
+# copy parameters file from DAKOTA into working directory
+cp $1 workdir/params.in
+
+# copy any necessary .sci files and data files into workdir
+cp automatic_test.xcos init_test_automatic.sce visualize_solution.sce f_pid.sci scilab_rosen_wrapper.sci workdir
+
+# -------------------------------
+# RUN the simulation from workdir
+# -------------------------------
+# launch Scilab with command mode (-r)
+# scilab_rosen_wrapper.sci will call the actual analysis file
+# rosenbrock.sci
+cd workdir
+
+echo scilab -nwni -e "exec init_test_automatic.sce; exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exec visualize_solution.sce; exit"
+
+/home/yann/Programmes/scilab-5.3.1/bin/scilab  -e "exec init_test_automatic.sce; exec scilab_rosen_wrapper.sci; scilab_rosen_wrapper('params.in', 'results.out'); exit"
+
+# *** --> The 'exit' command is crucial so Scilab will exit after running
+#         the analysis!
+
+# -------------------------------
+# write results.out and cleanup
+# -------------------------------
+mv results.out ../$2 
+
+cd ..
+\rm -rf workdir
+
+

Modification de propriétés sur PID/scilab_rosen_bb_simulator.sh
___________________________________________________________________
Ajouté : svn:executable
   + *

Index: PID/f_pid.sci
===================================================================
--- PID/f_pid.sci	(révision 0)
+++ PID/f_pid.sci	(révision 0)
@@ -0,0 +1,13 @@
+// Definition of the objective function
+
+function y = f(x)
+	context.w0 = w0;
+	context.m  = m;
+	context.K0 = K0;
+	context.P  = x(1);
+	context.I  = x(2);
+	Info = scicos_simulate(scs_m,list(),context,flag='nw');
+	y_error = mean(abs((block_output('values')(:,1) -  block_output('values')(:,2))));
+	y_diff  = mean(abs(diff(block_output('values')(:,2))));
+	y = 0.5*y_error + 0.5*1*y_diff; ...
+endfunction
